#line 1 "E:/Electro/Visual TFT/RGB_PWM_VTFT/RGB_PWM_VTFT_Code/mikroC PRO for ARM/RGB_PWM_VTFT_driver.c"
#line 1 "e:/electro/visual tft/rgb_pwm_vtft/rgb_pwm_vtft_code/mikroc pro for arm/rgb_pwm_vtft_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

typedef struct ProgressBar {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 unsigned int Background_Color;
 unsigned int Min;
 unsigned int Max;
 unsigned int Position;
 char Show_Position;
 char Show_Percentage;
 char Smooth;
 char Rounded;
 char Corner_Radius;
} TProgressBar;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

extern TScreen Main_Scr;
extern TProgressBar Red_bar;
extern TProgressBar Green_bar;
extern TProgressBar Blue_bar;
extern TCircle CircleLed;
extern TLabel lbl_Red;
extern TLabel lbl_Green;
extern TLabel lbl_Blue;
extern TLabel lbl_Led;
extern TLabel lbl_ctrl;
extern TLabel lbl_Toley;
extern TLabel * const code Screen1_Labels[6];
extern TCircle * const code Screen1_Circles[1];
extern TProgressBar * const code Screen1_ProgressBars[3];









extern char Red_bar_Caption[];
extern char Green_bar_Caption[];
extern char Blue_bar_Caption[];
extern char CircleLed_Caption[];
extern char lbl_Red_Caption[];
extern char lbl_Green_Caption[];
extern char lbl_Blue_Caption[];
extern char lbl_Led_Caption[];
extern char lbl_ctrl_Caption[];
extern char lbl_Toley_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
#line 1 "e:/electro/visual tft/rgb_pwm_vtft/rgb_pwm_vtft_code/mikroc pro for arm/rgb_pwm_vtft_resources.h"
const code char Tahoma29x29_Bold[];
const code char Tahoma32x33_Bold[];
const code char Tahoma11x13_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 7 "E:/Electro/Visual TFT/RGB_PWM_VTFT/RGB_PWM_VTFT_Code/mikroC PRO for ARM/RGB_PWM_VTFT_driver.c"
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;



sbit DRIVEX_LEFT at GPIOB_ODR.B1;
sbit DRIVEX_RIGHT at GPIOB_ODR.B8;
sbit DRIVEY_UP at GPIOB_ODR.B9;
sbit DRIVEY_DOWN at GPIOB_ODR.B0;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1500;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCircle *local_circle;
TCircle *exec_circle;
int circle_order;
TProgressBar *local_progress_bar;
TProgressBar *exec_progress_bar;
int progress_bar_order;


void Init_ADC() {
 ADC_Set_Input_Channel(_ADC_CHANNEL_8 | _ADC_CHANNEL_9);
 ADC1_Init();
 Delay_ms(100);
}
static void InitializeTouchPanel() {
 Init_ADC();
 TFT_Init(320, 240);

 TP_TFT_Init(320, 240, 8, 9);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Main_Scr;
 TProgressBar Red_bar;
char Red_bar_Caption[8] = "4\%";

 TProgressBar Green_bar;
char Green_bar_Caption[8] = "4\%";

 TProgressBar Blue_bar;
char Blue_bar_Caption[8] = "4\%";

 TCircle CircleLed;
 TLabel lbl_Red;
char lbl_Red_Caption[2] = "R";

 TLabel lbl_Green;
char lbl_Green_Caption[2] = "G";

 TLabel lbl_Blue;
char lbl_Blue_Caption[2] = "B";

 TLabel lbl_Led;
char lbl_Led_Caption[4] = "LED";

 TLabel lbl_ctrl;
char lbl_ctrl_Caption[11] = "Controller";

 TLabel lbl_Toley;
char lbl_Toley_Caption[11] = "Toley 2012";

 TLabel * const code Screen1_Labels[6]=
 {
 &lbl_Red,
 &lbl_Green,
 &lbl_Blue,
 &lbl_Led,
 &lbl_ctrl,
 &lbl_Toley
 };
 TCircle * const code Screen1_Circles[1]=
 {
 &CircleLed
 };
 TProgressBar * const code Screen1_ProgressBars[3]=
 {
 &Red_bar,
 &Green_bar,
 &Blue_bar
 };




static void InitializeObjects() {
 Main_Scr.Color = 0x0000;
 Main_Scr.Width = 320;
 Main_Scr.Height = 240;
 Main_Scr.LabelsCount = 6;
 Main_Scr.Labels = Screen1_Labels;
 Main_Scr.CirclesCount = 1;
 Main_Scr.Circles = Screen1_Circles;
 Main_Scr.ProgressBarsCount = 3;
 Main_Scr.ProgressBars = Screen1_ProgressBars;
 Main_Scr.ObjectsCount = 10;


 Red_bar.OwnerScreen = &Main_Scr;
 Red_bar.Order = 0;
 Red_bar.Left = 32;
 Red_bar.Top = 100;
 Red_bar.Width = 256;
 Red_bar.Height = 40;
 Red_bar.Pen_Width = 2;
 Red_bar.Pen_Color = 0xC618;
 Red_bar.Visible = 1;
 Red_bar.Active = 1;
 Red_bar.Transparent = 1;
 Red_bar.Caption = Red_bar_Caption;
 Red_bar.FontName = Tahoma29x29_Bold;
 Red_bar.Font_Color = 0x0000;
 Red_bar.Gradient = 0;
 Red_bar.Gradient_Orientation = 1;
 Red_bar.Gradient_Start_Color = 0x0000;
 Red_bar.Gradient_End_Color = 0xF800;
 Red_bar.Color = 0xF800;
 Red_bar.Background_Color = 0x8410;
 Red_bar.Min = 0;
 Red_bar.Max = 256;
 Red_bar.Position = 10;
 Red_bar.Show_Position = 1;
 Red_bar.Show_Percentage = 1;
 Red_bar.Smooth = 1;
 Red_bar.Rounded = 1;
 Red_bar.Corner_Radius = 1;

 Green_bar.OwnerScreen = &Main_Scr;
 Green_bar.Order = 1;
 Green_bar.Left = 32;
 Green_bar.Top = 140;
 Green_bar.Width = 256;
 Green_bar.Height = 40;
 Green_bar.Pen_Width = 2;
 Green_bar.Pen_Color = 0xC618;
 Green_bar.Visible = 1;
 Green_bar.Active = 1;
 Green_bar.Transparent = 1;
 Green_bar.Caption = Green_bar_Caption;
 Green_bar.FontName = Tahoma29x29_Bold;
 Green_bar.Font_Color = 0x0000;
 Green_bar.Gradient = 0;
 Green_bar.Gradient_Orientation = 1;
 Green_bar.Gradient_Start_Color = 0x0000;
 Green_bar.Gradient_End_Color = 0x0400;
 Green_bar.Color = 0x0400;
 Green_bar.Background_Color = 0x8410;
 Green_bar.Min = 0;
 Green_bar.Max = 256;
 Green_bar.Position = 10;
 Green_bar.Show_Position = 1;
 Green_bar.Show_Percentage = 1;
 Green_bar.Smooth = 1;
 Green_bar.Rounded = 1;
 Green_bar.Corner_Radius = 1;

 Blue_bar.OwnerScreen = &Main_Scr;
 Blue_bar.Order = 2;
 Blue_bar.Left = 32;
 Blue_bar.Top = 180;
 Blue_bar.Width = 256;
 Blue_bar.Height = 40;
 Blue_bar.Pen_Width = 2;
 Blue_bar.Pen_Color = 0xC618;
 Blue_bar.Visible = 1;
 Blue_bar.Active = 1;
 Blue_bar.Transparent = 1;
 Blue_bar.Caption = Blue_bar_Caption;
 Blue_bar.FontName = Tahoma29x29_Bold;
 Blue_bar.Font_Color = 0x0000;
 Blue_bar.Gradient = 0;
 Blue_bar.Gradient_Orientation = 1;
 Blue_bar.Gradient_Start_Color = 0x0000;
 Blue_bar.Gradient_End_Color = 0x001F;
 Blue_bar.Color = 0x001F;
 Blue_bar.Background_Color = 0x8410;
 Blue_bar.Min = 0;
 Blue_bar.Max = 256;
 Blue_bar.Position = 10;
 Blue_bar.Show_Position = 1;
 Blue_bar.Show_Percentage = 1;
 Blue_bar.Smooth = 1;
 Blue_bar.Rounded = 1;
 Blue_bar.Corner_Radius = 1;

 CircleLed.OwnerScreen = &Main_Scr;
 CircleLed.Order = 3;
 CircleLed.Left = 220;
 CircleLed.Top = 20;
 CircleLed.Radius = 24;
 CircleLed.Pen_Width = 0;
 CircleLed.Pen_Color = 0xC618;
 CircleLed.Visible = 1;
 CircleLed.Active = 1;
 CircleLed.Transparent = 1;
 CircleLed.Gradient = 0;
 CircleLed.Gradient_Orientation = 0;
 CircleLed.Gradient_Start_Color = 0xFFFF;
 CircleLed.Gradient_End_Color = 0xC618;
 CircleLed.Color = 0x0000;
 CircleLed.PressColEnabled = 1;
 CircleLed.Press_Color = 0x8410;
 CircleLed.OnUpPtr = 0;
 CircleLed.OnDownPtr = 0;
 CircleLed.OnClickPtr = 0;
 CircleLed.OnPressPtr = 0;

 lbl_Red.OwnerScreen = &Main_Scr;
 lbl_Red.Order = 4;
 lbl_Red.Left = 32;
 lbl_Red.Top = 16;
 lbl_Red.Width = 20;
 lbl_Red.Height = 36;
 lbl_Red.Visible = 1;
 lbl_Red.Active = 1;
 lbl_Red.Caption = lbl_Red_Caption;
 lbl_Red.FontName = Tahoma32x33_Bold;
 lbl_Red.Font_Color = 0xF800;
 lbl_Red.OnUpPtr = 0;
 lbl_Red.OnDownPtr = 0;
 lbl_Red.OnClickPtr = 0;
 lbl_Red.OnPressPtr = 0;

 lbl_Green.OwnerScreen = &Main_Scr;
 lbl_Green.Order = 5;
 lbl_Green.Left = 54;
 lbl_Green.Top = 16;
 lbl_Green.Width = 21;
 lbl_Green.Height = 36;
 lbl_Green.Visible = 1;
 lbl_Green.Active = 1;
 lbl_Green.Caption = lbl_Green_Caption;
 lbl_Green.FontName = Tahoma32x33_Bold;
 lbl_Green.Font_Color = 0x0400;
 lbl_Green.OnUpPtr = 0;
 lbl_Green.OnDownPtr = 0;
 lbl_Green.OnClickPtr = 0;
 lbl_Green.OnPressPtr = 0;

 lbl_Blue.OwnerScreen = &Main_Scr;
 lbl_Blue.Order = 6;
 lbl_Blue.Left = 76;
 lbl_Blue.Top = 16;
 lbl_Blue.Width = 19;
 lbl_Blue.Height = 36;
 lbl_Blue.Visible = 1;
 lbl_Blue.Active = 1;
 lbl_Blue.Caption = lbl_Blue_Caption;
 lbl_Blue.FontName = Tahoma32x33_Bold;
 lbl_Blue.Font_Color = 0x001F;
 lbl_Blue.OnUpPtr = 0;
 lbl_Blue.OnDownPtr = 0;
 lbl_Blue.OnClickPtr = 0;
 lbl_Blue.OnPressPtr = 0;

 lbl_Led.OwnerScreen = &Main_Scr;
 lbl_Led.Order = 7;
 lbl_Led.Left = 78;
 lbl_Led.Top = 44;
 lbl_Led.Width = 48;
 lbl_Led.Height = 32;
 lbl_Led.Visible = 1;
 lbl_Led.Active = 1;
 lbl_Led.Caption = lbl_Led_Caption;
 lbl_Led.FontName = Tahoma29x29_Bold;
 lbl_Led.Font_Color = 0xFFFF;
 lbl_Led.OnUpPtr = 0;
 lbl_Led.OnDownPtr = 0;
 lbl_Led.OnClickPtr = 0;
 lbl_Led.OnPressPtr = 0;

 lbl_ctrl.OwnerScreen = &Main_Scr;
 lbl_ctrl.Order = 8;
 lbl_ctrl.Left = 110;
 lbl_ctrl.Top = 68;
 lbl_ctrl.Width = 124;
 lbl_ctrl.Height = 32;
 lbl_ctrl.Visible = 1;
 lbl_ctrl.Active = 1;
 lbl_ctrl.Caption = lbl_ctrl_Caption;
 lbl_ctrl.FontName = Tahoma29x29_Bold;
 lbl_ctrl.Font_Color = 0xFFFF;
 lbl_ctrl.OnUpPtr = 0;
 lbl_ctrl.OnDownPtr = 0;
 lbl_ctrl.OnClickPtr = 0;
 lbl_ctrl.OnPressPtr = 0;

 lbl_Toley.OwnerScreen = &Main_Scr;
 lbl_Toley.Order = 9;
 lbl_Toley.Left = 30;
 lbl_Toley.Top = 82;
 lbl_Toley.Width = 55;
 lbl_Toley.Height = 15;
 lbl_Toley.Visible = 1;
 lbl_Toley.Active = 1;
 lbl_Toley.Caption = lbl_Toley_Caption;
 lbl_Toley.FontName = Tahoma11x13_Regular;
 lbl_Toley.Font_Color = 0xCE79;
 lbl_Toley.OnUpPtr = 0;
 lbl_Toley.OnDownPtr = 0;
 lbl_Toley.OnClickPtr = 0;
 lbl_Toley.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}






 void DeleteTrailingSpaces(char* str){
 char i;
 i = 0;
 while(1) {
 if(str[0] == ' ') {
 for(i = 0; i < strlen(str); i++) {
 str[i] = str[i+1];
 }
 }
 else
 break;
 }
 }

void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible == 1) {
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawCircle(TCircle *ACircle) {
 if (ACircle->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ACircle->Transparent, ACircle->Press_Color, ACircle->Gradient, ACircle->Gradient_Orientation,
 ACircle->Gradient_End_Color, ACircle->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ACircle->Transparent, ACircle->Color, ACircle->Gradient, ACircle->Gradient_Orientation,
 ACircle->Gradient_Start_Color, ACircle->Gradient_End_Color);
 }
 TFT_Set_Pen(ACircle->Pen_Color, ACircle->Pen_Width);
 TFT_Circle(ACircle->Left + ACircle->Radius,
 ACircle->Top + ACircle->Radius,
 ACircle->Radius);
 }
}

void UpdatePBPosition(TProgressBar *AProgressBar) {
 int move_offset;
 unsigned int locPosition = 0;
 unsigned cnt = 0;
 char tmpStr[8];
 unsigned int tmpWidth = 0;
 unsigned int tmpRound = 0;
 move_offset = 10;
 locPosition = (float)(AProgressBar->Position - AProgressBar->Min) / (float)(AProgressBar->Max - AProgressBar->Min) * 100;
 if (AProgressBar->Visible == 1) {
 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
 TFT_Set_Pen(AProgressBar->Background_Color, AProgressBar->Pen_Width);
 TFT_Write_Text_Return_Pos(AProgressBar->Caption, AProgressBar->Left, AProgressBar->Top);
 if (caption_height > AProgressBar->Height)
 caption_height = AProgressBar->Height;
 if (caption_length > AProgressBar->Width)
 caption_length = AProgressBar->Width;
 if (AProgressBar->Position < (AProgressBar->Left + (AProgressBar->Width - caption_length) / 2)) {
 TFT_Rectangle(AProgressBar->Left + (AProgressBar->Width - caption_length) / 2,
 AProgressBar->Top +(AProgressBar->Height - caption_height) / 2,
 AProgressBar->Left + (AProgressBar->Width - caption_length) / 2 + caption_length,
 AProgressBar->Top +(AProgressBar->Height - caption_height) / 2 + caption_height);
 }
 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient, AProgressBar->Gradient_Orientation, AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color);
 TFT_Set_Pen(AProgressBar->Pen_Color, AProgressBar->Pen_Width);
 if (AProgressBar->Rounded == 1) {
 if (locPosition > 0) {

 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient, AProgressBar->Gradient_Orientation, AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color);
 TFT_Rectangle(AProgressBar->Left + AProgressBar->Corner_Radius, AProgressBar->Top, AProgressBar->Left + AProgressBar->Corner_Radius + locPosition * (AProgressBar->Width-AProgressBar->Corner_Radius*2) / 100 , AProgressBar->Top + AProgressBar->Height);
 }
 }
 else {
 if (locPosition > 0) {
 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient, AProgressBar->Gradient_Orientation, AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color);
 TFT_Rectangle(AProgressBar->Left, AProgressBar->Top, AProgressBar->Left + (locPosition * AProgressBar->Width) / 100, AProgressBar->Top + AProgressBar->Height);
 }
 }

 if (AProgressBar->Smooth != 1) {
 if(AProgressBar->Rounded == 1) {
 tmpRound = AProgressBar->Corner_Radius;
 cnt = move_offset + tmpRound;
 tmpWidth = AProgressBar->Width - AProgressBar->Corner_Radius * 2;
 }
 else {
 tmpRound = 0;
 cnt = move_offset;
 tmpWidth = AProgressBar->Width;
 }
 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
 while (cnt-tmpRound < (locPosition * tmpWidth) / 100) {
 if (cnt - tmpRound + 3 >= tmpWidth * locPosition)
TFT_Rectangle(AProgressBar->Left + cnt, AProgressBar->Top, AProgressBar->Left + tmpRound + tmpWidth * locPosition , AProgressBar->Top + AProgressBar->Height);
 else
 TFT_Rectangle(AProgressBar->Left + cnt, AProgressBar->Top, AProgressBar->Left + cnt + 3, AProgressBar->Top + AProgressBar->Height);
 cnt = cnt + move_offset + 3;
 }
 }

 if (AProgressBar->Show_Position == 1){
 if (AProgressBar->Show_Percentage == 1) {
 IntToStr(locPosition , tmpStr);
 DeleteTrailingSpaces(tmpStr);
 strcpy(AProgressBar->Caption, tmpStr);
 strcat(AProgressBar->Caption, "\%");
 }
 else {
 IntToStr(AProgressBar->Position , tmpStr);
 DeleteTrailingSpaces(tmpStr);
 strcpy(AProgressBar->Caption, tmpStr);
 }
 TFT_Set_Font(AProgressBar->FontName, AProgressBar->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(AProgressBar->Caption, AProgressBar->Left, AProgressBar->Top);
 TFT_Write_Text(AProgressBar->Caption, AProgressBar->Left + (AProgressBar->Width - caption_length) / 2, AProgressBar->Top + (AProgressBar->Height - caption_height) / 2);
 }
 }
}

void DrawProgressBar(TProgressBar *AProgressBar) {
 int move_offset = 0;
 unsigned int locPosition = 0;
 unsigned cnt = 0;
 char tmpStr[8];
 unsigned int tmpWidth = 0;
 unsigned int tmpRound = 0;
 move_offset = 10;
 locPosition = (float)(AProgressBar->Position - AProgressBar->Min) / (float)(AProgressBar->Max - AProgressBar->Min) * 100;
 if (AProgressBar->Visible == 1) {
 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
 TFT_Set_Pen(AProgressBar->Pen_Color, AProgressBar->Pen_Width);
 if (AProgressBar->Rounded == 1) {

 TFT_Rectangle_Round_Edges(AProgressBar->Left, AProgressBar->Top, AProgressBar->Left + AProgressBar->Width, AProgressBar->Top + AProgressBar->Height, AProgressBar->Corner_Radius);
 if (locPosition > 0) {

 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient, AProgressBar->Gradient_Orientation, AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color);
 TFT_Rectangle(AProgressBar->Left + AProgressBar->Corner_Radius, AProgressBar->Top, AProgressBar->Left + AProgressBar->Corner_Radius + locPosition * (AProgressBar->Width-AProgressBar->Corner_Radius*2) / 100, AProgressBar->Top + AProgressBar->Height);
 }
 }
 else {

 TFT_Rectangle(AProgressBar->Left, AProgressBar->Top, AProgressBar->Left + AProgressBar->Width, AProgressBar->Top + AProgressBar->Height);
 if (locPosition > 0) {

 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Color, AProgressBar->Gradient, AProgressBar->Gradient_Orientation, AProgressBar->Gradient_Start_Color, AProgressBar->Gradient_End_Color);
 TFT_Rectangle(AProgressBar->Left, AProgressBar->Top, AProgressBar->Left + (locPosition * AProgressBar->Width) / 100, AProgressBar->Top + AProgressBar->Height);
 }
 }

 if (AProgressBar->Smooth != 1) {
 if(AProgressBar->Rounded == 1) {
 tmpRound = AProgressBar->Corner_Radius;
 cnt = move_offset + tmpRound;
 tmpWidth = AProgressBar->Width - AProgressBar->Corner_Radius * 2;
 }
 else {
 tmpRound = 0;
 cnt = move_offset;
 tmpWidth = AProgressBar->Width;
 }
 TFT_Set_Brush(AProgressBar->Transparent, AProgressBar->Background_Color, 0,0,0,0);
 while (cnt-tmpRound < (locPosition * tmpWidth) / 100) {
 if (cnt - tmpRound + 3 >= tmpWidth * locPosition)
 TFT_Rectangle(AProgressBar->Left + cnt, AProgressBar->Top, AProgressBar->Left + tmpRound + tmpWidth * locPosition , AProgressBar->Top + AProgressBar->Height);
 else
 TFT_Rectangle(AProgressBar->Left + cnt, AProgressBar->Top, AProgressBar->Left + cnt + 3, AProgressBar->Top + AProgressBar->Height);
 cnt = cnt + move_offset + 3;
 }
 }

 if (AProgressBar->Show_Position == 1){
 if (AProgressBar->Show_Percentage == 1) {
 IntToStr(locPosition , tmpStr);
 DeleteTrailingSpaces(tmpStr);
 strcpy(AProgressBar->Caption, tmpStr);
 strcat(AProgressBar->Caption, "\%");
 }
 else {
 IntToStr(AProgressBar->Position , tmpStr);
 DeleteTrailingSpaces(tmpStr);
 strcpy(AProgressBar->Caption, tmpStr);
 }
 TFT_Set_Font(AProgressBar->FontName, AProgressBar->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(AProgressBar->Caption, AProgressBar->Left, AProgressBar->Top);
 TFT_Write_Text(AProgressBar->Caption, AProgressBar->Left + (AProgressBar->Width - caption_length) / 2, AProgressBar->Top + (AProgressBar->Height - caption_height) / 2);
 }
 }
}

void DrawScreen(TScreen *aScreen) {
 int order;
 unsigned short label_idx;
 TLabel *local_label;
 unsigned short circle_idx;
 TCircle *local_circle;
 unsigned short progress_bar_idx;
 TProgressBar *local_progress_bar;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 label_idx = 0;
 circle_idx = 0;
 progress_bar_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 TFT_BLED = 0;
 TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
 TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 8, 9);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);
 TFT_Fill_Screen(CurrentScreen->Color);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 if (circle_idx < CurrentScreen->CirclesCount) {
 local_circle =  CurrentScreen->Circles[circle_idx] ;
 if (order == local_circle->Order) {
 circle_idx++;
 order++;
 DrawCircle(local_circle);
 }
 }

 if (progress_bar_idx < CurrentScreen->ProgressBarsCount) {
 local_progress_bar =  CurrentScreen->ProgressBars[progress_bar_idx] ;
 if (order == local_progress_bar->Order) {
 progress_bar_idx++;
 order++;
 DrawProgressBar(local_progress_bar);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 label_order = -1;
 circle_order = -1;
 progress_bar_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
 local_label =  CurrentScreen->Labels[_object_count] ;
 if (local_label->Active == 1) {
 if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
 local_label->Width, local_label->Height) == 1) {
 label_order = local_label->Order;
 exec_label = local_label;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->CirclesCount ; _object_count++ ) {
 local_circle =  CurrentScreen->Circles[_object_count] ;
 if (local_circle->Active == 1) {
 if (IsInsideObject(X, Y, local_circle->Left, local_circle->Top,
 (local_circle->Radius * 2), (local_circle->Radius * 2)) == 1) {
 circle_order = local_circle->Order;
 exec_circle = local_circle;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->ProgressBarsCount ; _object_count++ ) {
 local_progress_bar =  CurrentScreen->ProgressBars[_object_count] ;
 if (local_progress_bar->Active == 1) {
 if (IsInsideObject(X, Y, local_progress_bar->Left, local_progress_bar->Top,
 local_progress_bar->Width, local_progress_bar->Height) == 1) {
 progress_bar_order = local_progress_bar->Order;
 exec_progress_bar = local_progress_bar;
 }
 }
 }

 _object_count = -1;
 if (label_order > _object_count )
 _object_count = label_order;
 if (circle_order > _object_count )
 _object_count = circle_order;
 if (progress_bar_order > _object_count )
 _object_count = progress_bar_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_label = 0;
 exec_circle = 0;
 exec_progress_bar = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {
 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnPressPtr != 0) {
 exec_label->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == circle_order) {
 if (exec_circle->Active == 1) {
 if (exec_circle->OnPressPtr != 0) {
 exec_circle->OnPressPtr();
 return;
 }
 }
 }

 }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 4: {
 if (PressedObject != 0) {
 exec_circle = (TCircle*)PressedObject;
 if ((exec_circle->PressColEnabled == 1) && (exec_circle->OwnerScreen == CurrentScreen)) {
 DrawCircle(exec_circle);
 }
 break;
 }
 break;
 }
 }

 exec_label = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnUpPtr != 0)
 exec_label->OnUpPtr();
 if (PressedObject == (void *)exec_label)
 if (exec_label->OnClickPtr != 0)
 exec_label->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == circle_order) {
 if (exec_circle->Active == 1) {
 if (exec_circle->OnUpPtr != 0)
 exec_circle->OnUpPtr();
 if (PressedObject == (void *)exec_circle)
 if (exec_circle->OnClickPtr != 0)
 exec_circle->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_label = 0;
 exec_circle = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 PressedObject = (void *)exec_label;
 PressedObjectType = 2;
 if (exec_label->OnDownPtr != 0) {
 exec_label->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == circle_order) {
 if (exec_circle->Active == 1) {
 if (exec_circle->PressColEnabled == 1) {
 object_pressed = 1;
 DrawCircle(exec_circle);
 }
 PressedObject = (void *)exec_circle;
 PressedObjectType = 4;
 if (exec_circle->OnDownPtr != 0) {
 exec_circle->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (TP_TFT_Press_Detect()) {

 if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {
 GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_9);
 TFT_BLED = 1;
 TFT_Set_Default_Mode();
 TP_TFT_Set_Default_Mode();
}

void Start_TP() {
 Init_MCU();

 InitializeTouchPanel();


 TP_TFT_Set_Calibration_Consts(239, 3700, 224, 3679);

 InitializeObjects();
 display_width = Main_Scr.Width;
 display_height = Main_Scr.Height;
 DrawScreen(&Main_Scr);
}
