/*
 * Project name:
     RGB_PWM_VTFT.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     2012-10-29
 * Time of creation
     18:42:21
 * Test configuration:
     MCU:             STM32F107VC
     Dev.Board:       EasyMx_PRO_v7_for_STM32_ARM
                      http://www.mikroe.com/eng/products/view/852/easymx-pro-v7-for-stm32/
     Oscillator:      72000000 Hz
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/eng/products/view/752/mikroc-pro-for-arm/
 */

#include "RGB_PWM_VTFT_objects.h"

//*** Pin definitions ***//
sbit Red at GPIOD_ODR.B12;
sbit Green at GPIOD_ODR.B13;
sbit Blue at GPIOD_ODR.B14;

//*** Global Variables ***//
unsigned int pwm_ratio;

//*** Function Prototype ***//
void Set_PWM(unsigned short, unsigned short, unsigned short);
unsigned int pwm_8bits(unsigned int, unsigned short);

void main() 
{
  unsigned int x_coord, y_coord;
  
  Start_TP();

  pwm_ratio = PWM_TIM4_Init(1000);

  PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,0) , _PWM_NON_INVERTED, _PWM_CHANNEL1);
  PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,0) , _PWM_NON_INVERTED, _PWM_CHANNEL2);
  PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,0) , _PWM_NON_INVERTED, _PWM_CHANNEL3);

  PWM_TIM4_Start(_PWM_CHANNEL1, &_GPIO_MODULE_TIM4_CH1_PD12);
  PWM_TIM4_Start(_PWM_CHANNEL2, &_GPIO_MODULE_TIM4_CH2_PD13);
  PWM_TIM4_Start(_PWM_CHANNEL3, &_GPIO_MODULE_TIM4_CH3_PD14);
  
  while (1) {
    Check_TP();
    
    if (TP_TFT_Press_Detect())
    {
      if (TP_TFT_Get_Coordinates(&x_coord, &y_coord) == 0)
      {
        if(x_coord > 32 && x_coord < 288 && y_coord > 100 && y_coord < 220)
        {
          if(y_coord > 100 && y_coord < 140)
          {
            Red_bar.Position = x_coord - 32;
            DrawProgressBar(&Red_bar);
          }
          else if(y_coord > 140 && y_coord < 180)
          {
            Green_bar.Position = x_coord - 32;
            DrawProgressBar(&Green_bar);
          }
          else if(y_coord > 180 && y_coord < 220)
          {
            Blue_bar.Position = x_coord - 32;
            DrawProgressBar(&Blue_bar);
          }
        }
      }
      Set_PWM(Red_bar.Position,Green_bar.Position,Blue_bar.Position);
    }
  }
}

void Set_PWM(unsigned short Red, unsigned short Green, unsigned short Blue)
{
 CircleLed.Color = TFT_RGBToColor16bit(Red,Green,Blue);
 DrawCircle(&CircleLed);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,Red), _PWM_NON_INVERTED, _PWM_CHANNEL1);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,Green), _PWM_NON_INVERTED, _PWM_CHANNEL2);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,Blue), _PWM_NON_INVERTED, _PWM_CHANNEL3);
}

unsigned int pwm_8bits(unsigned int ratio, unsigned short byte)
{
 unsigned long temp;
 temp = ((unsigned long) ratio * (255 - byte)) / 255;
 return (unsigned int)temp;
}