#line 1 "E:/Electro/Visual TFT/RGB_PWM_VTFT/RGB_PWM_VTFT_Code/mikroC PRO for ARM/RGB_PWM_VTFT_main.c"
#line 1 "e:/electro/visual tft/rgb_pwm_vtft/rgb_pwm_vtft_code/mikroc pro for arm/rgb_pwm_vtft_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

typedef struct ProgressBar {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 unsigned int Background_Color;
 unsigned int Min;
 unsigned int Max;
 unsigned int Position;
 char Show_Position;
 char Show_Percentage;
 char Smooth;
 char Rounded;
 char Corner_Radius;
} TProgressBar;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned short ObjectsCount;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

extern TScreen Main_Scr;
extern TProgressBar Red_bar;
extern TProgressBar Green_bar;
extern TProgressBar Blue_bar;
extern TCircle CircleLed;
extern TLabel lbl_Red;
extern TLabel lbl_Green;
extern TLabel lbl_Blue;
extern TLabel lbl_Led;
extern TLabel lbl_ctrl;
extern TLabel lbl_Toley;
extern TLabel * const code Screen1_Labels[6];
extern TCircle * const code Screen1_Circles[1];
extern TProgressBar * const code Screen1_ProgressBars[3];









extern char Red_bar_Caption[];
extern char Green_bar_Caption[];
extern char Blue_bar_Caption[];
extern char CircleLed_Caption[];
extern char lbl_Red_Caption[];
extern char lbl_Green_Caption[];
extern char lbl_Blue_Caption[];
extern char lbl_Led_Caption[];
extern char lbl_ctrl_Caption[];
extern char lbl_Toley_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
#line 22 "E:/Electro/Visual TFT/RGB_PWM_VTFT/RGB_PWM_VTFT_Code/mikroC PRO for ARM/RGB_PWM_VTFT_main.c"
sbit Red at GPIOD_ODR.B12;
sbit Green at GPIOD_ODR.B13;
sbit Blue at GPIOD_ODR.B14;


unsigned int pwm_ratio;


void Set_PWM(unsigned short, unsigned short, unsigned short);
unsigned int pwm_8bits(unsigned int, unsigned short);

void main()
{
 unsigned int x_coord, y_coord;

 Start_TP();

 pwm_ratio = PWM_TIM4_Init(1000);

 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,0) , _PWM_NON_INVERTED, _PWM_CHANNEL1);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,0) , _PWM_NON_INVERTED, _PWM_CHANNEL2);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,0) , _PWM_NON_INVERTED, _PWM_CHANNEL3);

 PWM_TIM4_Start(_PWM_CHANNEL1, &_GPIO_MODULE_TIM4_CH1_PD12);
 PWM_TIM4_Start(_PWM_CHANNEL2, &_GPIO_MODULE_TIM4_CH2_PD13);
 PWM_TIM4_Start(_PWM_CHANNEL3, &_GPIO_MODULE_TIM4_CH3_PD14);

 while (1) {
 Check_TP();

 if (TP_TFT_Press_Detect())
 {
 if (TP_TFT_Get_Coordinates(&x_coord, &y_coord) == 0)
 {
 if(x_coord > 32 && x_coord < 288 && y_coord > 100 && y_coord < 220)
 {
 if(y_coord > 100 && y_coord < 140)
 {
 Red_bar.Position = x_coord - 32;
 DrawProgressBar(&Red_bar);
 }
 else if(y_coord > 140 && y_coord < 180)
 {
 Green_bar.Position = x_coord - 32;
 DrawProgressBar(&Green_bar);
 }
 else if(y_coord > 180 && y_coord < 220)
 {
 Blue_bar.Position = x_coord - 32;
 DrawProgressBar(&Blue_bar);
 }
 }
 }
 Set_PWM(Red_bar.Position,Green_bar.Position,Blue_bar.Position);
 }
 }
}

void Set_PWM(unsigned short Red, unsigned short Green, unsigned short Blue)
{
 CircleLed.Color = TFT_RGBToColor16bit(Red,Green,Blue);
 DrawCircle(&CircleLed);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,Red), _PWM_NON_INVERTED, _PWM_CHANNEL1);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,Green), _PWM_NON_INVERTED, _PWM_CHANNEL2);
 PWM_TIM4_Set_Duty(pwm_8bits(pwm_ratio,Blue), _PWM_NON_INVERTED, _PWM_CHANNEL3);
}

unsigned int pwm_8bits(unsigned int ratio, unsigned short byte)
{
 unsigned long temp;
 temp = ((unsigned long) ratio * (255 - byte)) / 255;
 return (unsigned int)temp;
}
