typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Circle {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Radius;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCircle;

typedef struct ProgressBar {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  unsigned int  Background_Color;
  unsigned int  Min;
  unsigned int  Max;
  unsigned int  Position;
  char          Show_Position;
  char          Show_Percentage;
  char          Smooth;
  char          Rounded;
  char          Corner_Radius;
} TProgressBar;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           CirclesCount;
  TCircle                * const code *Circles;
  unsigned int           ProgressBarsCount;
  TProgressBar              * const code *ProgressBars;
};

extern   TScreen                Main_Scr;
extern   TProgressBar                 Red_bar;
extern   TProgressBar                 Green_bar;
extern   TProgressBar                 Blue_bar;
extern   TCircle                CircleLed;
extern   TLabel                 lbl_Red;
extern   TLabel                 lbl_Green;
extern   TLabel                 lbl_Blue;
extern   TLabel                 lbl_Led;
extern   TLabel                 lbl_ctrl;
extern   TLabel                 lbl_Toley;
extern   TLabel                 * const code Screen1_Labels[6];
extern   TCircle                * const code Screen1_Circles[1];
extern   TProgressBar               * const code Screen1_ProgressBars[3];



/////////////////////////
// Events Code Declarations
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Red_bar_Caption[];
extern char Green_bar_Caption[];
extern char Blue_bar_Caption[];
extern char CircleLed_Caption[];
extern char lbl_Red_Caption[];
extern char lbl_Green_Caption[];
extern char lbl_Blue_Caption[];
extern char lbl_Led_Caption[];
extern char lbl_ctrl_Caption[];
extern char lbl_Toley_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
